#! /usr/bin/env python

from xml.dom.minidom import Document, parseString
from os import environ, getuid, fork
from time import sleep
from pwd import getpwuid
from sss.ssslib import comm_lib
from sss.server import SSSSelectEventReceiver
from sys import argv

class procevent(SSSSelectEventReceiver):
    def HandleXMLEvent(self, xe, (peer,port)):
        for event in xe.childNodes:
            if event.getAttribute("msg") == "process_end":
                self.shut = 1
            print event.toxml()
        response=Document().createElement('event-ok')
        return response
    
if __name__ == '__main__':
    executable = raw_input( 'executable? ' )
    numprocs   = raw_input( 'numprocs? ' )
    # submitter = environ['USER']
    submitter = getpwuid(getuid())[0]
    output = 'display'
    path = environ['PATH']
    cwd = environ['PWD']
    
    msg = Document().createElement('create-process-group')
    msg.setAttribute("pgid",'*')
    msg.setAttribute('totalprocs', numprocs )
    msg.setAttribute('submitter', submitter )
    msg.setAttribute('output', output )
    ps =  Document().createElement('process-spec')
    ps.setAttribute("user", submitter)
    ps.setAttribute('exec', executable )
    ps.setAttribute('path', path )
    ps.setAttribute('cwd', cwd )
    msg.appendChild(ps)

    print msg.toprettyxml()
    
    comm = comm_lib(debug='-d' in argv)
    process_manager = comm.ClientInit('process-manager')
    comm.SendMessage(process_manager,msg.toxml())
    ack = comm.RecvMessage(process_manager)
    comm.ClientClose(process_manager)
    ack_dom = parseString(ack)
    pgid=ack_dom.documentElement.getAttribute('pgid')
    print "Got PGID %s\nwaiting for event data"%(pgid)

    debug=argv.count('-d')
    server=procevent(component='process-manager',msg='**',data=pgid,debug=debug)
    server.ServeForever()

