#include <Python.h>
#include <stdio.h>
#include <validate.h>

static PyObject *ValidationException;

static PyObject *validate_py(PyObject *self,PyObject *args){
  char *string;
  char *schema;
  char errbuf[128];
  char *rc;
  
  if (!PyArg_ParseTuple(args,"ss",&string,&schema)){
    return NULL;
  }

  rc = validate_xml(string,schema,errbuf,128);
  
  if (rc[0] != '\0'){
    PyErr_SetString(ValidationException,rc);
    free(rc);
    return NULL;
  }

  free(rc);

  return Py_BuildValue("i",10);
  
}

static PyMethodDef validate_methods[] = {
  {"validate",validate_py,METH_VARARGS},
  {NULL,NULL}
};

void initvalidate(void){
  PyObject *module,*dict;
  
  module = Py_InitModule("validate",validate_methods);
  dict = PyModule_GetDict(module);

  ValidationException = PyErr_NewException("validate.ValidationException",NULL,NULL);
  PyDict_SetItemString(dict,"ValidationException",ValidationException);
  
}


